;; Patch for simulator problems with *pset
;; Handles case that value and dest are same field
;; Gives correct notification

(in-package '*lisp)

(defun *lisp-simulator-p ()
 (member :*LISP-SIMULATOR *features*)
)

;; Alternate for *pset which works in current simulator.  It is *pset
;; when using hardware

(defmacro *psetx (comb val dest &rest stuff)
 (list*
  (if (*lisp-simulator-p) '*special-pset '*pset)
  comb val dest stuff)
)

(*defun *special-pset (comb val dest cube
		       &optional (notify nil) (c-mode :collisions-allowed))
(*let (D N)
   (*all (*set N nil!!))
   (*pset comb val D cube N c-mode)
   (*all (*when N
       (*set dest D)
       (if notify (*set notify T!!)))) ; end *all
  )
)
   
